/*###############################################################################
# Linux Management Providers (LMP), BIOS provider package
# Copyright (C) 2010 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by <Author(s)>, <Affiliation>, <Year>
###############################################################################*/

#ifndef OPENDRIM_BIOSCAPABILITIESACCESS_H_
#define OPENDRIM_BIOSCAPABILITIESACCESS_H_

#include "BIOS_Common.h"

#include "OpenDRIM_BIOSCapabilities.h"
#include "assocOpenDRIM_BIOSCapabilities.h"

int BIOS_OpenDRIM_BIOSCapabilities_load(const CMPIBroker* broker, string& errorMessage);

int BIOS_OpenDRIM_BIOSCapabilities_unload(string& errorMessage);

int BIOS_OpenDRIM_BIOSCapabilities_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_BIOSCapabilities>& instances, const char** properties, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSCapabilities_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_BIOSCapabilities& instance, const char** properties, string& errorMessage);

int BIOS_OpenDRIM_BIOSCapabilities_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_BIOSCapabilities& newInstance, const OpenDRIM_BIOSCapabilities& oldInstance, const char** properties, string& errorMessage);

int BIOS_OpenDRIM_BIOSCapabilities_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_BIOSCapabilities& instance, string& errorMessage);

int BIOS_OpenDRIM_BIOSCapabilities_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_BIOSCapabilities& instance, string& errorMessage);

int BIOS_OpenDRIM_BIOSCapabilities_associatorCapabilitiesToManagedElement(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Capabilities_instance, const char** properties, vector<Instance>& ManagedElement_associatedInstances, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSCapabilities_associatorManagedElementToCapabilities(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& ManagedElement_instance, const char** properties, vector<Instance>& Capabilities_associatedInstances, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSCapabilities_referenceCapabilitiesToManagedElement(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Capabilities_instance, const vector<Instance>& ManagedElement_instances, vector<OpenDRIM_BIOSCapabilities>& OpenDRIM_BIOSCapabilities_instances, const char** properties, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSCapabilities_referenceManagedElementToCapabilities(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& ManagedElement_instance, const vector<Instance>& Capabilities_instances, vector<OpenDRIM_BIOSCapabilities>& OpenDRIM_BIOSCapabilities_instances, const char** properties, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSCapabilities_populate(OpenDRIM_BIOSCapabilities& instance, string& errorMessage);

#endif /*OPENDRIM_BIOSCAPABILITIESACCESS_H_*/
