/*###############################################################################
# Linux Management Providers (LMP), BIOS provider package
# Copyright (C) 2010 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by <Author(s)>, <Affiliation>, <Year>
###############################################################################*/

#ifndef OPENDRIM_BIOSHOSTEDSERVICEACCESS_H_
#define OPENDRIM_BIOSHOSTEDSERVICEACCESS_H_

#include "BIOS_Common.h"

#include "OpenDRIM_BIOSHostedService.h"
#include "assocOpenDRIM_BIOSHostedService.h"

int BIOS_OpenDRIM_BIOSHostedService_load(const CMPIBroker* broker, string& errorMessage);

int BIOS_OpenDRIM_BIOSHostedService_unload(string& errorMessage);

int BIOS_OpenDRIM_BIOSHostedService_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_BIOSHostedService>& instances, const char** properties, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSHostedService_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_BIOSHostedService& instance, const char** properties, string& errorMessage);

int BIOS_OpenDRIM_BIOSHostedService_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_BIOSHostedService& newInstance, const OpenDRIM_BIOSHostedService& oldInstance, const char** properties, string& errorMessage);

int BIOS_OpenDRIM_BIOSHostedService_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_BIOSHostedService& instance, string& errorMessage);

int BIOS_OpenDRIM_BIOSHostedService_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_BIOSHostedService& instance, string& errorMessage);

int BIOS_OpenDRIM_BIOSHostedService_associatorAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const char** properties, vector<Instance>& Dependent_associatedInstances, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSHostedService_associatorDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const char** properties, vector<Instance>& Antecedent_associatedInstances, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSHostedService_referenceAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const vector<Instance>& Dependent_instances, vector<OpenDRIM_BIOSHostedService>& OpenDRIM_BIOSHostedService_instances, const char** properties, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSHostedService_referenceDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const vector<Instance>& Antecedent_instances, vector<OpenDRIM_BIOSHostedService>& OpenDRIM_BIOSHostedService_instances, const char** properties, string& errorMessage, const string& discriminant);

int BIOS_OpenDRIM_BIOSHostedService_populate(OpenDRIM_BIOSHostedService& instance, string& errorMessage);

#endif /*OPENDRIM_BIOSHOSTEDSERVICEACCESS_H_*/
