/*###############################################################################
# Linux Management Providers (LMP), BIOS provider package
# Copyright (C) 2010 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by <Author(s)>, <Affiliation>, <Year>
###############################################################################*/

#include "cmpiOpenDRIM_ServiceAffectsBIOSAttribute.h"

CMPIObjectPath* BIOS_OpenDRIM_ServiceAffectsBIOSAttribute_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_ServiceAffectsBIOSAttribute& instance) {
	_E_;
	Objectpath op(broker, OpenDRIM_ServiceAffectsBIOSAttribute_classnames[0], OpenDRIM_ServiceAffectsBIOSAttribute_NAMESPACE);

	if (!instance.AffectedElement_isNULL)
		op.addKey("AffectedElement", instance.AffectedElement);

	if (!instance.AffectingElement_isNULL)
		op.addKey("AffectingElement", instance.AffectingElement);

	_L_;
	return op.getHdl();
}

CMPIInstance* BIOS_OpenDRIM_ServiceAffectsBIOSAttribute_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_ServiceAffectsBIOSAttribute& instance) {
	_E_;
	Objectpath op(broker, BIOS_OpenDRIM_ServiceAffectsBIOSAttribute_toCMPIObjectPath(broker, instance));
	Instance ci(broker, op);

	if (!instance.ElementEffects_isNULL)
		ci.setProperty("ElementEffects", instance.ElementEffects);

	if (!instance.OtherElementEffectsDescriptions_isNULL)
		ci.setProperty("OtherElementEffectsDescriptions", instance.OtherElementEffectsDescriptions);

	_L_;
	return ci.getHdl();
}

void BIOS_OpenDRIM_ServiceAffectsBIOSAttribute_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_ServiceAffectsBIOSAttribute& instance) {
	_E_;
	Objectpath op(broker, (CMPIObjectPath*) ref);

	if (op.getKey("AffectedElement", instance.AffectedElement) == OK)
		instance.AffectedElement_isNULL = false;

	if (op.getKey("AffectingElement", instance.AffectingElement) == OK)
		instance.AffectingElement_isNULL = false;

	_L_;
}

void BIOS_OpenDRIM_ServiceAffectsBIOSAttribute_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_ServiceAffectsBIOSAttribute& instance) {
	_E_;
	Instance inst(broker, (CMPIInstance*) ci);

	if (inst.getProperty("AffectedElement", instance.AffectedElement) == OK)
		instance.AffectedElement_isNULL = false;

	if (inst.getProperty("AffectingElement", instance.AffectingElement) == OK)
		instance.AffectingElement_isNULL = false;

	if (inst.getProperty("ElementEffects", instance.ElementEffects) == OK)
		instance.ElementEffects_isNULL = false;

	if (inst.getProperty("OtherElementEffectsDescriptions", instance.OtherElementEffectsDescriptions) == OK)
		instance.OtherElementEffectsDescriptions_isNULL = false;

	_L_;
}

